VERSION 1.0 CLASS
BEGIN
  MultiUse = 0   'False
END
Attribute VB_Name = "MPMAPI"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
'Copyright (c) 1996  Ziff-Davis Publishing Company.
'All rights reserved.
'First Published in PC Magazine, US Edition, [CoverDate].
'
'Programmed by John McSorley
'
Option Explicit

'Init done flag
Dim imInitDone As Integer

'Collection of mail messages
Private MsgCol As New Collection

Public Function Check4NewMail() As Integer
'Purpose: Check for change in unread messages

    Dim lMsgCount As Long
    Dim i As Long
    Dim j As Long
    Dim StartIndex As Integer
    Dim oMsg As MailMessage
    Dim iMatch As Integer
    Dim iAllMatch As Integer
    Dim iLoadCol As Integer
    
    lMsgCount = GetUnreadCount()
    
    If lMsgCount > Count Then
        'Count greater so must be new mail
        iLoadCol = True
        Check4NewMail = True
    ElseIf lMsgCount < Count Then
        'Count less need to
        iLoadCol = True
        Check4NewMail = True
    Else
    
        UnRead = 0
        StartIndex = 0
        iAllMatch = True
        For i = 0 To frmMail.MapiMess.MsgCount - 1
            frmMail.MapiMess.MsgIndex = i
            iMatch = False
            For j = 1 To Count
                If frmMail.MapiMess.MsgID = Item(j).Key Then
                    iMatch = True
                End If
            Next j
            
            iAllMatch = iAllMatch And iMatch
            
        Next i
        
        If iAllMatch = False Then
            'No match so must be new mail
            iLoadCol = True
            Check4NewMail = True
        Else
            iLoadCol = False
            Check4NewMail = False
        End If
            
    End If
    
    'Do we need to reload collection?
    If iLoadCol = True Then
        'Yes
        LoadCol
    End If
    
End Function

Private Sub Clear()
'Purpose: Clear mail collection

    Dim i As Integer
    
    For i = Count To 1 Step -1
        MsgCol.Remove i
    Next i
    
End Sub

Public Function Count() As Long
'Purpose: return number of message in collection
    
    Count = MsgCol.Count
    
End Function


Public Function Item(ByVal Index As Variant) As MailMessage
'Purpose: return one mail message
    
    Set Item = MsgCol.Item(Index)
    
End Function

Public Function Add(MsgSubject As String, MsgOrig As String, Key As String) As MailMessage
'Purpose: add a new mail message to collection
    
    Dim oMsg As New MailMessage
    
    With oMsg
        .MsgSubject = MsgSubject
        .MsgOrigDisplayName = MsgOrig
        .Key = Key
        MsgCol.Add oMsg, Key
    End With
    
    'return new message
    Set Add = oMsg
    
        
End Function

Private Function GetUnreadCount() As Integer
'Purpose: Reads unread mail messages and returns the count.

    Screen.MousePointer = 11
    frmMail.MapiMess.FetchUnreadOnly = 1
    frmMail.MapiMess.Action = vbMessageFetch
    
    GetUnreadCount = frmMail.MapiMess.MsgCount
    
    Screen.MousePointer = 0

End Function

Private Sub LoadCol()
'Purpose:
' This procedure loads the mail message headers
' into the Collection.
    
    Dim StartIndex As Integer
    Dim i As Integer
    Dim oMsg As MailMessage
    
    
    
    'Clear out collection
    Clear
    
    UnRead = 0
    StartIndex = 0
    For i = 0 To frmMail.MapiMess.MsgCount - 1
        frmMail.MapiMess.MsgIndex = i
        Set oMsg = Add(frmMail.MapiMess.MsgSubject, frmMail.MapiMess.MsgOrigDisplayName, frmMail.MapiMess.MsgID)
        
    Next i


End Sub

Public Sub LogOffUser()
'Purpose: Logs user off mail system

    Dim i As Integer
    
    On Error Resume Next
    'frmMail.MapiSess.Action = 2
    frmMail.MapiSess.SignOff
    If Err <> 0 Then
        'MsgBox "Logoff Failure: " + Error$
    Else
        frmMail.MapiMess.SessionID = 0
                          
        ' Reset the caption for the status bar labels.
        frmMail.MsgCountLbl = "Off Line"
        frmMail.UnreadLbl = ""
    
        Unload frmMail
    
    End If


End Sub


Private Sub LoadList()
'Purpose: Load listbox from mail collection
    
    Dim StartIndex As Integer
    Dim i As Integer
    Dim a$, b$, c$
    
    
' This procedure loads the mail message headers
' into the frmMail.MList.  Unread messages have
' Chr$(187) placed at the beginning of the string.
    frmMail.MList.Clear
    UnRead = 0
    StartIndex = 0
    For i = 0 To frmMail.MapiMess.MsgCount - 1
        frmMail.MapiMess.MsgIndex = i
        If Not frmMail.MapiMess.MsgRead Then
            a$ = Chr$(187) + " "
            If UnRead = 0 Then
                StartIndex = i  ' Start position in the mail list.
            End If
            UnRead = UnRead + 1
        Else
            a$ = "  "
        End If
        a$ = a$ + Mid$(Format$(frmMail.MapiMess.MsgOrigDisplayName, "!" + String$(10, "@")), 1, 10)
        If frmMail.MapiMess.MsgSubject <> "" Then
            b$ = Mid$(Format$(frmMail.MapiMess.MsgSubject, "!" + String$(35, "@")), 1, 35)
        Else
            b$ = String$(30, " ")
        End If
        c$ = Mid$(Format$(DateFromMapiDate(frmMail.MapiMess.MsgDateReceived, conMailListView), "!" + String$(15, "@")), 1, 15)
        frmMail.MList.AddItem a$ + Chr$(9) + b$ + Chr$(9) + c$
        frmMail.MList.Refresh
    Next i

    frmMail.MList.ListIndex = StartIndex
    

    ' Adjust the value of the labels displaying message counts.
    If UnRead Then
        frmMail.UnreadLbl = " - " + Format$(UnRead) + " Unread"
        'frmMail.Icon = frmMail.NewMail.Picture
    Else
        frmMail.UnreadLbl = ""
        'frmMail.Icon = frmMail.nonew.Picture
    End If
End Sub
    



Private Function GetMessageCount() As Integer
'Purpose: Reads all mail messages and return the count.

    Screen.MousePointer = 11
    frmMail.MapiMess.FetchUnreadOnly = 0
    frmMail.MapiMess.Action = vbMessageFetch
    GetMessageCount = frmMail.MapiMess.MsgCount
    Screen.MousePointer = 0
End Function





Public Function Logon(UserName As String, Password As String) As Integer
'Purpose: Log user on to mail system and fill collection with unread mail

    Dim iCnt As Integer
    
    If imInitDone = True Then
    
        'Set Logon params
        'Can't set these for MS Exchange but may need for other mail systems
        'frmMail.MapiSess.UserName = UserName
        'frmMail.MapiSess.Password = Password
        
        
        frmMail.MapiSess.LogonUI = True
        
        ' Log onto the mail system.
        On Error Resume Next
        'frmMail.MapiSess.Action = 1
        frmMail.MapiSess.SignOn
        
        If Err <> 0 Then
            'MsgBox "Logon Failure: " + Error$
            Logon = False
        Else
            Screen.MousePointer = 11
            frmMail.MapiMess.SessionID = frmMail.MapiSess.SessionID
            ' Get the message count.
            'GetMessageCount
            iCnt = GetUnreadCount()
            
            ' Load the mail list collection with message information.
            Screen.MousePointer = 11
            'Call LoadList
            LoadCol
            
            Screen.MousePointer = 0
            
            Logon = True
        End If
        
        
    Else
    
        Logon = False
    End If
    

End Function


Private Sub Class_Initialize()
'Purpose: Initialization of Mail server
    
    Load frmMail
    'frmMail.Show
    imInitDone = True

End Sub

Private Sub Class_Terminate()
'Purpose: Terminate the server
    
    'clear out collection
    Clear
    Unload frmMail
    
End Sub


