Attribute VB_Name = "Globals"
'Copyright (c) 1996  Ziff-Davis Publishing Company.
'All rights reserved.
'First Published in PC Magazine, US Edition, [CoverDate].
'
'Programmed by John McSorley
'
Option Explicit





Public Const scAppName = "MailPage"
Public Const scCopyRight = "Copyright 1996 by John McSorley"

'Property values collection object
Public oProps As New StuffCol

'Mail object
Public oPageMail As Object

'Lists
Dim sFromList() As String
Dim sSubjList() As String

'Page log file record definition
Type PageRec
    Key As String * 64
    deleted As String * 1
End Type

'page log record
Dim tmPageRec As PageRec

'Property values identifiers
Public Const scNumServNum = "NumServNum"
Public Const scMailLogin = "MailLogin"
Public Const scMailPassword = "MailPassword"
Public Const scMailObj = "MailObj"
Public Const scPagerObj = "PagerObj"
Public Const scPagerType = "PagerType"
Public Const scPort = "Port"
Public Const scDispStatus = "DispStatus"
Public Const scDispRcv = "DispRcv"

Public Const scFromList = "FromList"
Public Const scSubjList = "SubjList"
Public Const scIgnoreOldUnread = "IgnoreOldUnread"
Public Const scAlphaServNum = "AlphaServNum"
Public Const scAlphaId = "AlphaId"
Public Const scAlphaPassword = "AlphaPassword"

Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long

Public Const HELP_COMMAND = &H102&
Public Const HELP_CONTENTS = &H3&
Public Const HELP_CONTEXT = &H1          '  Display topic in ulTopic
Public Const HELP_CONTEXTPOPUP = &H8&
Public Const HELP_FINDER = &HB
Public Const HELP_FORCEFILE = &H9&
Public Const HELP_HELPONHELP = &H4       '  Display help on using help
Public Const HELP_INDEX = &H3            '  Display index
Public Const HELP_KEY = &H101            '  Display topic for keyword in offabData
Public Const HELP_MULTIKEY = &H201&
Public Const HELP_PARTIALKEY = &H105&
Public Const HELP_QUIT = &H2             '  Terminate help
Public Const HELP_SETCONTENTS = &H5&
Public Const HELP_SETINDEX = &H5         '  Set current Index for multi index help
Public Const HELP_SETWINPOS = &H203&
 



Function DoAlpha(sFrom As String, sSubject As String) As Integer
'Purpose: Perform alpha style page

    Dim i As Integer
    Dim j As Integer
    Dim sValue As String
    Dim sToken As String
    Dim iMatch As Integer
    Dim iWho As Integer
    Dim iWhat As Integer
    Dim sTelNum As String
    Dim sMsg As String
    Dim oPg As Object
    Dim iRet As Integer
    Dim iPort As Integer
            
            
            
    'Look for from list match
    sValue = UCase$(sFrom)
    iMatch = 0
    iWho = 0
    For j = 1 To UBound(sFromList)
        iMatch = InStr(sValue, sFromList(j))
        If iMatch <> 0 Then
            iWho = j
            Exit For
        End If
    Next j
    
'    If iMatch <> 0 Then
'        'We did find someone
'        sMsg = "999" & Format$(oPageMail.Count, "000") & Format$(iWho, "00")
'
'    Else
'        'no match so send 00
'        sMsg = "999" & Format$(oPageMail.Count, "000") & "00"
'    End If
    
    
    'Look for from list match
    sValue = UCase$(sSubject)
    iMatch = 0
    iWhat = 0
    For j = 1 To UBound(sSubjList)
        iMatch = InStr(sValue, sSubjList(j))
        If iMatch <> 0 Then
            iWhat = j
            Exit For
        End If
    Next j
    
'    If iMatch <> 0 Then
'        'We did find something
'        sMsg = sMsg & Format$(iWhat, "00")
'
'    Else
'        'no match so send 00
'        sMsg = sMsg & "00"
'    End If
    
    sMsg = Trim$(Left$(sFrom, 15)) & " : " & sSubject
    sMsg = Trim$(Left$(sMsg, 80))
    
    
    'Get Service Number property
    sTelNum = oProps.Item(scAlphaServNum).Value
    
    'Get Com port
    iPort = Val(Mid$(oProps.Item(scPort).Value, 4, 1))
    
    'Create paging object
    Set oPg = CreateObject(oProps.Item(scPagerObj).Value)
    
    'Initialize it
    iRet = oPg.Init(iPort, oProps.Item(scDispStatus).Value, oProps.Item(scDispRcv).Value)
    
    If iRet <> 0 Then
        MsgBox "Could not initialize pager object Err=" & Str$(iRet)
        DoAlpha = False
    Else
    
        'OK page with built message
        iRet = oPg.AlphaPage(sTelNum, sMsg, oProps.Item(scAlphaId).Value, oProps.Item(scAlphaPassword).Value)
        
        
        'Terminate page object
        oPg.Term
        
        'Just to be sure destroy object
        Set oPg = Nothing
        
        'success
        DoAlpha = True
        
    End If

End Function

Function DoNumeric(sFrom As String, sSubject As String) As Integer
'Purpose: Perform numeric style page

    Dim i As Integer
    Dim j As Integer
    Dim sValue As String
    Dim sToken As String
    Dim iMatch As Integer
    Dim iWho As Integer
    Dim iWhat As Integer
    Dim sTelNum As String
    Dim sMsg As String
    Dim oPg As Object
    Dim iRet As Integer
    Dim iPort As Integer
            
            
            
    'Look for from list match
    sValue = UCase$(sFrom)
    iMatch = 0
    For j = 1 To UBound(sFromList)
        iMatch = InStr(sValue, sFromList(j))
        If iMatch <> 0 Then
            iWho = j
            Exit For
        End If
    Next j
    
    If iMatch <> 0 Then
        'We did find someone
        sMsg = "999" & Format$(oPageMail.Count, "000") & Format$(iWho, "00")
        
    Else
        'no match so send 00
        sMsg = "999" & Format$(oPageMail.Count, "000") & "00"
    End If
    
    
    'Look for from list match
    sValue = UCase$(sSubject)
    iMatch = 0
    For j = 1 To UBound(sSubjList)
        iMatch = InStr(sValue, sSubjList(j))
        If iMatch <> 0 Then
            iWhat = j
            Exit For
        End If
    Next j
    If iMatch <> 0 Then
        'We did find something
        sMsg = sMsg & Format$(iWhat, "00")
        
    Else
        'no match so send 00
        sMsg = sMsg & "00"
    End If
    
                
    
    
    'Get Service Number property
    sTelNum = oProps.Item(scNumServNum).Value
    
    'Get Com port
    iPort = Val(Mid$(oProps.Item(scPort).Value, 4, 1))
    
    'Create paging object
    Set oPg = CreateObject(oProps.Item(scPagerObj).Value)
    
    'Initialize it
    iRet = oPg.Init(iPort, oProps.Item(scDispStatus).Value, oProps.Item(scDispRcv).Value)
    
    If iRet <> 0 Then
        MsgBox "Could not initialize pager object Err=" & Str$(iRet)
        DoNumeric = False
    Else
        'OK page with built message
        iRet = oPg.NumericPage(sTelNum, sMsg)
        
        
        'Terminate page object
        oPg.Term
        
        'Just to be sure destroy object
        Set oPg = Nothing
        
        'success
        DoNumeric = True
        
    End If
            
            

End Function


Sub DoProperties()
'Purpose: Do properties settings

    'load form in preparation of filling it
    Load frmProps
    
    'fill the form based on property settings
    oProps.FillForm frmProps
    
    'show it
    frmProps.Show vbModal
    
    'check if user pressed OK?
    If frmProps.Cancel = False Then
        'OK get settings from form
        'Unload data from form
        oProps.UnloadForm frmProps
        'save the settings
        oProps.SaveAllSet "Config"
    Else
        'user canceled
    
    End If
    Unload frmProps

End Sub

Sub FillLists()
'Purpose: Fill the comparison lists from settings

    Dim i As Integer
    Dim sValue As String
    Dim sToken As String

    
    'Get From List
    sValue = oProps.Item(scFromList).Value
    i = 0
    ReDim sFromList(i)
    Do Until sValue = ""
        sToken = Token$(sValue, "|")
        If sToken <> "" Then
            i = i + 1
            ReDim Preserve sFromList(i)
            sFromList(i) = UCase$(sToken)
        End If
    Loop

    'Get Subject List
    sValue = oProps.Item(scSubjList).Value
    i = 0
    ReDim sSubjList(i)
    Do Until sValue = ""
        sToken = Token$(sValue, "|")
        If sToken <> "" Then
            i = i + 1
            ReDim Preserve sSubjList(i)
            sSubjList(i) = UCase$(sToken)
        End If
    Loop

End Sub

Function GoOffLine() As Integer
'Purpose: user chose to go offline
    
    'Logoff the user
    oPageMail.LogOffUser
    
    'Done using object so free it
    Set oPageMail = Nothing
    
    GoOffLine = True
    
    
End Function

Function GoOnline() As Integer
'Purpose: user chose to go online

    Dim i As Integer
    Dim s_MailObj As String
    Dim i_ret As Integer

    'Get Mail Object Property value
    s_MailObj = oProps.Item(scMailObj).Value

    On Error Resume Next
    
    Set oPageMail = CreateObject(s_MailObj)
    If Err <> 0 Then
        MsgBox "Could not create Mail Object, Please check properties"
        'Call DoProperties
        GoOnline = False
    Else
    
    
        On Error GoTo 0
        
        'Logon to mail system
        i_ret = oPageMail.Logon(oProps.Item(scMailLogin).Value, oProps.Item(scMailPassword).Value)
        
        If i_ret = False Then
            MsgBox "Could not logon to mail"
            GoOnline = False
            Exit Function
        End If
        
        'Clear out List
        frmPageCli!MailList.Clear
        
        'Fill Unread mail list
        For i = 1 To oPageMail.Count
            frmPageCli!MailList.AddItem oPageMail.Item(i).MsgOrigDisplayName & " : " & oPageMail.Item(i).MsgSubject
        Next i
        
        frmPageCli!lblUnread = Str$(oPageMail.Count) & " - Unread messages"
        
        'Enable periodic processes timer
        frmPageCli!Timer1.Enabled = True
        
        'Set status display
        frmPageCli!lblStatus = "Online"
        
        DoEvents
        
        'House cleaning of page log file
        Call CleanPageFile
        
        'Startup check if we should ignore unread messages
        If oProps.Item(scIgnoreOldUnread).Value = 1 Then
            'Yes we should so mark them as not needing pages
            For i = 1 To oPageMail.Count
                SetPrevPage (oPageMail.Item(i).Key)
            Next i
        Else
            If ActiveTime() = True Then
                'not ignoring them so check if we need to page them
                Call CheckToPage
            End If
        End If
        
        GoOnline = True
        
    End If

End Function

Sub MainInit()
'Purpose: Application initialization
    
    Dim i_ret As Integer
    Dim s_MailObj
    Dim i As Integer
    
    frmPageCli.Show
    
    DoEvents
        
    'Define Properties
    Call DefineProps
    
    'Load All Properties from Registry/INI file
    oProps.LoadAllSet "Config"
    
    'Display if we are active or not
    If ActiveTime() = True Then
        frmPageCli!lblOperating = "Active"
    Else
        frmPageCli!lblOperating = "Inactive"
    End If


'    'Try to go Online with Mail
'    i_ret = GoOnline()
'    If i_ret = False Then
'        frmPageCli!mnuFileOnline.Checked = False
'    Else
'        frmPageCli!mnuFileOnline.Checked = True
'
'    End If
    

End Sub




Function Token$(tmp$, search$)
'Purpose: get next token from string based on search seperator
    Dim X As Integer
    
    X = InStr(1, tmp$, search$)
    If X Then
       Token$ = Mid$(tmp$, 1, X - 1)
       tmp$ = Mid$(tmp$, X + 1)
    Else
       Token$ = tmp$
       tmp$ = ""
    End If
End Function



Function ActiveTime() As Integer
'Purpose: Check if current time is active/inactive

    Dim sDay As String
    Dim sHr As String
    
    'Get todays setting
    sDay = oProps.Item("OpTimes" & Trim$(Str$(WeekDay(Now) - 1))).Value
    
    'get nows hour setting
    sHr = Mid$(sDay, Hour(Now) + 1, 1)
    
    'If 1 user said we should be active
    If sHr = "1" Then
        ActiveTime = True
    Else
        ActiveTime = False
    End If
    
End Function


Function CheckPrevPage(Key As String) As Integer
'Purpose: Check if mail message has been paged before

    Dim i As Long
    Dim iFnum As Integer
    Dim sFile As String
    Dim t_PageRec As PageRec
    Dim lRecLen As Long
    Dim iMatch As Integer
    Dim lRecs As Long
    
    On Error GoTo CheckPrevPageErr
    
    'build file name
    sFile = App.Path & "\mspage.dat"
    
    iFnum = FreeFile
    lRecLen = Len(t_PageRec)
    
    Open sFile For Random As iFnum Len = lRecLen
    
    lRecs = LOF(iFnum) / lRecLen
    
    For i = 1 To lRecs
        Get #iFnum, , t_PageRec
        If Key = Left$(t_PageRec.Key, Len(Key)) Then
            'match so have paged before
            iMatch = True
            Exit For
        End If
    Next i
    
    Close iFnum
        
    'return result
    CheckPrevPage = iMatch
    
    Exit Function
    
CheckPrevPageErr:

    MsgBox "Could not check for previous pages Err=" & Error$
    Exit Function
    
    
End Function

Sub CheckToPage()
'Purpose: Check if mail messages need paging

    Dim i As Integer
    Dim j As Integer
    Dim iRet As Integer
    Dim iPort As Integer
    
    
    
    'Loop thru unread messages
    For i = 1 To oPageMail.Count
        
        'Check if we paged on this one before
        If CheckPrevPage(oPageMail.Item(i).Key) = False Then
            'No previous page lets do one
            
            'Fill the Lists
            Call FillLists
            
            If oProps.Item(scPagerType).Value = 0 Then
            
                'Do a Numeric style page
                iRet = DoNumeric(oPageMail.Item(i).MsgOrigDisplayName, oPageMail.Item(i).MsgSubject)
            
            Else
                'Do a Alpha style page
                iRet = DoAlpha(oPageMail.Item(i).MsgOrigDisplayName, oPageMail.Item(i).MsgSubject)
            
            End If
            
            
            'Log page
            SetPrevPage oPageMail.Item(i).Key
            
        End If
    
    Next i
    
            

    
End Sub

Sub CleanPageFile()
'Purpose: Cleanup page file of old entries (i.e. things not in unread list)
    
    Dim i As Long
    Dim j As Long
    Dim iFnum As Integer
    Dim sFile As String
    Dim t_PageRec As PageRec
    Dim lRecLen As Long
    Dim iMatch As Integer
    Dim lRecs As Long
    Dim sKey As String
    
    sFile = App.Path & "\mspage.dat"
    
    iFnum = FreeFile
    lRecLen = Len(t_PageRec)
    
    Open sFile For Random As iFnum Len = lRecLen
    
    lRecs = LOF(iFnum) / lRecLen
    
    For i = 1 To lRecs
        Get #iFnum, , t_PageRec
        For j = 1 To oPageMail.Count
            sKey = oPageMail.Item(j).Key
            
            If sKey = Left$(t_PageRec.Key, Len(sKey)) Then
                iMatch = True
                Exit For
            End If
        Next j
        
        'was there a unread message to match page file
        If iMatch = False Then
            'No then mark record deleted
            t_PageRec.deleted = "Y"
            Put #iFnum, i, t_PageRec
        End If
        
            
    Next i
    
    Close iFnum
        
    

End Sub

Sub DefineProps()
'Purpose: Define property settings

    Dim oCfgItem As Stuff
    Const icNumeric = 1
    Const icString = 0
    
    'Add Key, default value, Numeric or String type
    Set oCfgItem = oProps.Add(scNumServNum, "1-XXX-YYY-ZZZZ,,,", icString)
    Set oCfgItem = oProps.Add(scMailLogin, "", icString)
    Set oCfgItem = oProps.Add(scMailPassword, "", icString)
    Set oCfgItem = oProps.Add(scMailObj, "MPMAPIServ.MPMAPI", icString)
    Set oCfgItem = oProps.Add(scPagerObj, "Paging.Pager", icString)
    Set oCfgItem = oProps.Add(scPagerType, "0", icNumeric)
    Set oCfgItem = oProps.Add(scPort, "COM1:", icString)
    Set oCfgItem = oProps.Add(scFromList, "", icString)
    Set oCfgItem = oProps.Add(scSubjList, "", icString)
    Set oCfgItem = oProps.Add(scIgnoreOldUnread, "0", icNumeric)
    Set oCfgItem = oProps.Add(scAlphaServNum, "1-XXX-YYY-ZZZZ", icString)
    Set oCfgItem = oProps.Add(scAlphaId, "", icString)
    Set oCfgItem = oProps.Add(scAlphaPassword, "", icString)
    Set oCfgItem = oProps.Add(scDispStatus, "1", icNumeric)
    Set oCfgItem = oProps.Add(scDispRcv, "1", icNumeric)

    
    Set oCfgItem = oProps.Add("OpTimes0", "000000000000000000000000", icString)
    Set oCfgItem = oProps.Add("OpTimes1", "000000011111111110000000", icString)
    Set oCfgItem = oProps.Add("OpTimes2", "000000011111111110000000", icString)
    Set oCfgItem = oProps.Add("OpTimes3", "000000011111111110000000", icString)
    Set oCfgItem = oProps.Add("OpTimes4", "000000011111111110000000", icString)
    Set oCfgItem = oProps.Add("OpTimes5", "000000011111111110000000", icString)
    Set oCfgItem = oProps.Add("OpTimes6", "000000000000000000000000", icString)
    

End Sub


Sub PeriodicProcs()
'Purpose: Periodic processes are started here

    Dim i_ret As Integer
    Dim i As Integer
    
    'Check if we are active or sleeping
    If ActiveTime() = True Then
        frmPageCli!lblOperating = "Active"
        
        'Check if Mail online
        If frmPageCli!mnuFileOnline.Checked = True Then
            'Check for new mail
            i_ret = oPageMail.Check4NewMail()
            If i_ret = True Then
                'yes mail changed
                'repopulate display
                frmPageCli!MailList.Clear
                For i = 1 To oPageMail.Count
                    frmPageCli!MailList.AddItem oPageMail.Item(i).MsgOrigDisplayName & " : " & oPageMail.Item(i).MsgSubject
                Next i
                frmPageCli!lblUnread = Str$(oPageMail.Count) & " - Unread messages"
                
                DoEvents
            
                'Check unread messages for ones to page
                Call CheckToPage
            
            End If
        End If
            
    
    Else
        frmPageCli!lblOperating = "Inactive"
    End If

    
End Sub


Sub SetPrevPage(Key As String)
'Purpose: log fact that we paged this mail message

    Dim i As Long
    Dim iFnum As Integer
    Dim sFile As String
    Dim t_PageRec As PageRec
    Dim lRecLen As Long
    Dim iMatch As Integer
    Dim lRecs As Long
    
    sFile = App.Path & "\mspage.dat"
    
    iFnum = FreeFile
    lRecLen = Len(t_PageRec)
    
    Open sFile For Random As iFnum Len = lRecLen
    
    lRecs = LOF(iFnum) / lRecLen
    
    'Check for previous record
    For i = 1 To lRecs
        Get #iFnum, , t_PageRec
        If Key = t_PageRec.Key Then
            iMatch = True
            Exit For
            t_PageRec.deleted = "N"
            Put #iFnum, i, t_PageRec
        End If
    Next i
    
    If iMatch = False Then
        'Check for deleted record to reuse
        For i = 1 To lRecs
            Get #iFnum, , t_PageRec
            If t_PageRec.deleted = "Y" Then
                iMatch = True
                Exit For
                t_PageRec.deleted = "N"
                t_PageRec.Key = Key & Space$(64 - Len(Key))
                Put #iFnum, i, t_PageRec
            End If
        Next i
    
        'Check if used a deleted record
        If iMatch = False Then
            'No so append one
            t_PageRec.deleted = "N"
            t_PageRec.Key = Key & Space$(64 - Len(Key))
            Put #iFnum, lRecs + 1, t_PageRec
        End If
    
    End If
    
    
    Close iFnum
        

End Sub


