VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Pager"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
'Copyright (c) 1996  Ziff-Davis Publishing Company.
'All rights reserved.
'First Published in PC Magazine, US Edition, [CoverDate].
'
'Programmed by John McSorley
'
Option Explicit


Dim imInitDone As Integer


Dim smMsgs() As String

    
    'States
    Const icInitModem = 0
    Const icDialing = 1
    Const icConnected = 2
    Const icIDequal = 3
    Const icPager = 4
    Const icSecurity = 5
    Const icMessage = 6
    Const icMore = 7
    Const icCommandMode = 8
    Const icExit = 99
    
    'Messages
    Const icOK = 0
    Const icConnect = 1
    Const icRing = 2
    Const icNoCarrier = 3
    Const icError = 4
    Const icRcvID = 5
    Const icRcvPager = 6
    Const icRcvSecurity = 7
    Const icRcvMessage = 8
    Const icRcvRejected = 9
    Const icRcvMore = 10
    Const icRcvHang = 11
    

'Modem init strings
Dim sNumInit As String
Dim sAlphaInit As String

Public Function AlphaPage(sTelNum As String, sMsg As String, sID As String, sPassword As String) As Integer
'Purpose: Perform an alpha style page

    Dim DialString As String
    Dim FromModem As String
    Dim dummy
    Dim rcv As String
    Dim v_start As Variant
    
    Dim i_ret As Integer
    Dim InitString As String
    Dim sDataOut As String
    Dim sData As String
    Dim iExit As Integer
    
    Dim iState As Integer
    Dim iMsgIdx As Integer
    
    
    
    On Error GoTo AlphaPageErr

    If imInitDone = True Then
    
        frmPager!lblNum = sTelNum
        frmPager!lblMsg = sMsg
        
        
        'Initialize messages
        ReDim smMsgs(11)
        
'        smMsgs(icOK) = "0" & Chr$(13)
'        smMsgs(icConnect) = "1" & Chr$(13)
'        smMsgs(icRing) = "2" & Chr$(13)
'        smMsgs(icNoCarrier) = "3" & Chr$(13)
'        smMsgs(icError) = "4" & Chr$(13)
        
        smMsgs(icOK) = "OK"
        smMsgs(icConnect) = "CONNECT"
        smMsgs(icRing) = "RING"
        smMsgs(icNoCarrier) = "NO CARRIER"
        smMsgs(icError) = "ERROR"
        
        smMsgs(icRcvID) = "ID="
        smMsgs(icRcvPager) = "pager"
        smMsgs(icRcvSecurity) = "security"
        smMsgs(icRcvMessage) = "message"
        smMsgs(icRcvRejected) = "rejected"
        smMsgs(icRcvMore) = "more"
        smMsgs(icRcvHang) = "hang"

      
        
        
        iState = icInitModem
        iExit = False
        
        While iExit = False
        
            Select Case iState
                Case icInitModem
                    'Initialization string
                    'sDataOut = "ATM0E0Q0V0X0" & Chr$(13)
                    'sDataOut = "ATM0E0Q0V1X0" & Chr$(13)
                    'sDataOut = "ATM1V1" & Chr$(13)
                    sDataOut = sAlphaInit & Chr$(13)

                Case icDialing
                    Call Wait(2)
                    sDataOut = "ATDT" & sTelNum & Chr$(13)
                    
                Case icConnected
                    sDataOut = Chr$(13)
                    
                Case icIDequal
                    sDataOut = "M" & Chr$(13)
                    
                Case icPager
                    sDataOut = sID & Chr$(13)
                    
                Case icSecurity
                    sDataOut = sPassword & Chr$(13)
                
                Case icMessage
                    sDataOut = sMsg & Chr$(13)
                    
                Case icMore
                      sDataOut = "+++"
                    
                Case icCommandMode
                    sDataOut = "ATH" & Chr$(13)
                    
                Case icExit
                    iExit = True
            
            End Select
            
            
            If iExit = False Then
                'Display output data
                frmPager!txtRcv.SelText = sDataOut
                
                ' Flush the input buffer.
                frmPager!Comm1.InBufferCount = 0
                
                ' Send data
                frmPager!Comm1.Output = sDataOut
                
                ' Wait for message to come back from the modem.
                i_ret = Wait4Msgs(smMsgs(), sData, iMsgIdx)
                
                If i_ret = True Then
                    'Go to next state
                    iState = NextState(iState, iMsgIdx)
                    
                Else
                    'timeout so exit
                    iExit = True
                End If
                
                
            End If
            
            'Wait a few seconds
            'Call Wait(1)
            
        
        Wend
        
    
    Else
    
    
    End If
    
    
    AlphaPage = True
    
    Exit Function

AlphaPageErr:
    
    AlphaPage = False
    
    Exit Function

End Function


Public Function Init(CommPort As Integer, Display As Integer, DispRcv As Integer) As Integer
Attribute Init.VB_Description = "Initialize pager object with comm port and display options."
'Purpose: Initialize server

    Dim InitString As String
    Dim i_ret As Integer
    
    Load frmPager

    If DispRcv <> 0 Then
        frmPager.picRcv.Visible = True
        frmPager.Height = (frmPager.Height - frmPager.ScaleHeight) + frmPager.picMsgs.Height + frmPager.picRcv.Height
    Else
        frmPager.picRcv.Visible = False
        frmPager.Height = (frmPager.Height - frmPager.ScaleHeight) + frmPager!picMsgs.Height
        'frmPager.Height = frmPager!picMsgs.Height
    End If
    DoEvents
    
    If Display <> 0 Then
        frmPager.Show
    End If
    
    ' Setting InputLen to 0 tells MSComm to read the entire
    ' contents of the input buffer when the Input property
    ' is used.
    frmPager!Comm1.InputLen = 0
    
    'Set Communication Port number
    frmPager!Comm1.CommPort = CommPort

    'Communications port settings.
    'Can page at 300 baud
    frmPager!Comm1.Settings = "300,E,7,1"

    
    'Open the communications port.
    On Error Resume Next
    frmPager!Comm1.PortOpen = True
    If Err Then
       'Error so return the error
       Init = Err
       Exit Function
    End If

    
    'Success
    Init = 0
    imInitDone = True

End Function

Private Function NextState(iState As Integer, iMsgIdx As Integer) As Integer
'Purpose: Get Next state based on current state and received message

    Dim iRetState As Integer

    Select Case iState
    
        Case icInitModem
            Select Case iMsgIdx
                Case icOK
                    iRetState = icDialing
                Case Else 'icError
                    iRetState = icExit
            End Select
            
        Case icDialing
            Select Case iMsgIdx
                'Case icOK
                Case icConnect
                    iRetState = icConnected
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                Case icError
                    iRetState = icExit
                'Case icRcvID
                'Case icRcvPager
                'Case icRcvSecurity
                'Case icRcvMessage
                'Case icRcvRejected
                'Case icRcvMore
                'Case icRcvHang
            End Select
        
        Case icConnected
            Select Case iMsgIdx
                'Case icOK
                'Case icConnect
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                'Case icError
                
                Case icRcvID
                    iRetState = icIDequal
                'Case icRcvPager
                'Case icRcvSecurity
                'Case icRcvMessage
                'Case icRcvRejected
                'Case icRcvMore
                'Case icRcvHang
                Case Else
                    iRetState = icExit
            End Select
        Case icIDequal
            Select Case iMsgIdx
                'Case icOK
                'Case icConnect
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                'Case icError
                  
                'Case icRcvID
                Case icRcvPager
                    iRetState = icPager
                'Case icRcvSecurity
                'Case icRcvMessage
                'Case icRcvRejected
                'Case icRcvMore
                'Case icRcvHang
                Case Else
                    iRetState = icExit
            End Select
        Case icPager
            Select Case iMsgIdx
                'Case icOK
                'Case icConnect
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                'Case icError
                  
                'Case icRcvID
                'Case icRcvPager
                    
                Case icRcvSecurity
                    iRetState = icSecurity
                Case icRcvMessage
                    iRetState = icMessage
                'Case icRcvRejected
                'Case icRcvMore
                'Case icRcvHang
                Case Else
                    iRetState = icExit
            End Select
        Case icSecurity
            Select Case iMsgIdx
                'Case icOK
                'Case icConnect
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                'Case icError
                  
                'Case icRcvID
                'Case icRcvPager
                    
                'Case icRcvSecurity
                
                Case icRcvMessage
                    iRetState = icMessage
                'Case icRcvRejected
                'Case icRcvMore
                'Case icRcvHang
                Case Else
                    iRetState = icExit
            End Select
        Case icMessage
            Select Case iMsgIdx
                'Case icOK
                'Case icConnect
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                'Case icError
                  
                'Case icRcvID
                'Case icRcvPager
                    
                'Case icRcvSecurity
                
                'Case icRcvMessage
                    
                Case icRcvRejected
                    iRetState = icExit
                Case icRcvMore
                    iRetState = icMore
                Case icRcvHang
                    iRetState = icMore
                Case Else
                    iRetState = icExit
            End Select

        
        Case icMore
            Select Case iMsgIdx
                'Case icOK
                'Case icConnect
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                'Case icError
                  
                'Case icRcvID
                'Case icRcvPager
                    
                'Case icRcvSecurity
                
                'Case icRcvMessage
                    
                'Case icRcvRejected
                    
                Case icRcvMore
                    iRetState = icMore
                Case icRcvHang
                    iRetState = icMore
                
                Case Else
                    iRetState = icExit
            End Select
        
        Case icCommandMode
            Select Case iMsgIdx
                Case icOK
                    iRetState = icCommandMode
                'Case icConnect
                'Case icRing
                Case icNoCarrier
                    iRetState = icExit
                'Case icError
                  
                'Case icRcvID
                'Case icRcvPager
                    
                'Case icRcvSecurity
                
                'Case icRcvMessage
                    
                'Case icRcvRejected
                    
                'Case icRcvMore
                '    iRetState = icMore
                'Case icRcvHang
                '    iRetState = icMore
                
                Case Else
                    iRetState = icExit
            End Select



    End Select

    NextState = iRetState


'    Select Case iMsgIdx
'        Case icOK
'        Case icConnect
'        Case icRing
'        Case icNoCarrier
'        Case icError
'        Case icRcvID
'        Case icRcvPager
'        Case icRcvSecurity
'        Case icRcvMessage
'        Case icRcvRejected
'        Case icRcvMore
'        Case icRcvHang
'    End Select



End Function

Public Function NumericPage(sTelNum As String, sMsg As String)
Attribute NumericPage.VB_Description = "Perform a Numeric style page."
'Purpose: perform a numeric style page
    
    Dim DialString As String
    Dim FromModem As String
    Dim dummy
    Dim rcv As String
    Dim v_start As Variant
    
    Dim i_ret As Integer
    Dim InitString As String
    Dim sData As String
    
    
    On Error GoTo NumericPageErr

    If imInitDone = True Then
    
        frmPager!lblNum = sTelNum
        frmPager!lblMsg = sMsg
        
        'Initialization string
        'InitString = "ATM0E1Q0V0X0" & Chr$(13)
        'InitString = "ATM1V0" & Chr$(13)
        InitString = sNumInit & Chr$(13)
        
        ' Flush the input buffer.
        frmPager!Comm1.InBufferCount = 0
        
        ' Send init string.
        frmPager!Comm1.Output = InitString
        
        ' Wait for "0" CR to come back from the modem.
        i_ret = Wait4Msg("0" & Chr$(13), sData)
        
        'Wait a few seconds
        'Call Wait(5)
    
        'Lets make sure things are settled
        InitString = "AT" & Chr$(13)
        
        ' Flush the input buffer.
        frmPager!Comm1.InBufferCount = 0
        
        ' send init string.
        frmPager!Comm1.Output = InitString
        
        ' Wait for "0" CR to come back from the modem.
        i_ret = Wait4Msg("0" & Chr$(13), sData)
    
        ' AT is the Hayes compatible ATTENTION command and is required to send commands to the modem.
        ' DT means "Dial Tone." The Dial command uses touch tones, as opposed to pulse (DP = Dial Pulse).
        ' A semicolon tells the modem to return to command mode after dialing (important).
        ' A carriage return, Chr$(13), is required when sending commands to the modem.
        ' A ; indicates stay in command mode
        DialString = "ATDT" & sTelNum & sMsg & "#;" & Chr$(13)
    
        
        ' Flush the input buffer.
        frmPager!Comm1.InBufferCount = 0
        
        ' Dial the number.
        frmPager!Comm1.Output = DialString
        
        
        ' Wait for "0" CR to come back from the modem.
        i_ret = Wait4Msg("0" & Chr$(13), sData)
        
        If i_ret = False Then
            NumericPage = False
            Exit Function
        End If
        
        
        
        ' Flush the input buffer.
        frmPager!Comm1.InBufferCount = 0
        
        
        ' Disconnect the modem.
        frmPager!Comm1.Output = "ATH" + Chr$(13)
        
    
        ' Wait for "0" CR to come back from the modem.
        i_ret = Wait4Msg("0" & Chr$(13), sData)
        
        If i_ret = False Then
            NumericPage = False
            Exit Function
        End If
    
        'Success
        NumericPage = True
        
    Else
        'Init not done so return false
        NumericPage = False
    End If
    
    Exit Function

NumericPageErr:

    'Error so return false
    NumericPage = False
    
    Exit Function
    

End Function


Public Sub Term()
Attribute Term.VB_Description = "Terminate the pager object"
'Purpose: terminate the server
    
    If frmPager!Comm1.PortOpen = True Then
        ' Close the port.
        frmPager!Comm1.PortOpen = False

    End If
    'Unload the form we don't need it anymore
    Unload frmPager
    
End Sub


Private Sub Wait(Secs As Integer)
'Purpose: Wait specified number of seconds

    Dim v_start As Variant
    
    v_start = Now
    While DateDiff("s", v_start, Now) < Secs
        DoEvents
    Wend
    
End Sub


Private Function Wait4Msg(Msg As String, RetStr As String) As Integer
'Purpose: Wait for supplied message or timeout period
    
    Dim FromModem As String
    Dim dummy
    Dim rcv As String
    Dim v_start As Variant
    Dim i_TimeOut As Integer
    
    Const icTimeout = 45 'sec timeout

    FromModem = ""
        
    ' Wait for message to come back from the modem or timeout.
    v_start = Now
    Do
        dummy = DoEvents()
        ' If there is data in the buffer, then read it.
        If frmPager!Comm1.InBufferCount Then
            rcv = frmPager!Comm1.Input
            FromModem = FromModem & rcv
            'display the data
            frmPager!txtRcv.SelText = rcv
            ' Check for match.
            If InStr(1, FromModem, Msg, 1) Then
                'Got OK so we are done
                Exit Do
            End If
        End If
            
        'check to see if times up
        If DateDiff("s", v_start, Now) > icTimeout Then
            i_TimeOut = True
            Exit Do
        End If
    Loop
    
    'Set return string
    RetStr = FromModem
    
    If i_TimeOut = True Then
        Wait4Msg = False
    Else
        Wait4Msg = True
    End If

End Function


Private Function Wait4Msgs(Msgs() As String, RetStr As String, iIndex As Integer) As Integer
'Purpose: Wait for match in set of messages or timeout period
    
    Dim FromModem As String
    Dim dummy
    Dim rcv As String
    Dim v_start As Variant
    Dim i_TimeOut As Integer
    Dim i_match As Integer
    Dim i As Integer
    
    
    Const icTimeout = 45 'sec timeout

    FromModem = ""
        
    ' Wait for data to come back from the modem.
    v_start = Now
    Do
        dummy = DoEvents()
        ' If there is data in the buffer, then read it.
        If frmPager!Comm1.InBufferCount Then
            rcv = frmPager!Comm1.Input
            FromModem = FromModem & rcv
            frmPager!txtRcv.SelText = rcv
            ' Check for match.
            For i = LBound(Msgs) To UBound(Msgs)
                If InStr(1, FromModem, Msgs(i), 1) Then
                    'return which match
                    iIndex = i
                    'Got match so we are done
                    Exit Do
                End If
            Next i
            
        End If
            
        'check if times up
        If DateDiff("s", v_start, Now) > icTimeout Then
            i_TimeOut = True
            Exit Do
        End If
    Loop
    
    'Set return string
    RetStr = FromModem
    
    If i_TimeOut = True Then
        Wait4Msgs = False
    Else
        Wait4Msgs = True
    End If

End Function


Private Sub Class_Initialize()
    Dim sValue As String
    
    'sValue = PCMagRegQueryValue(scAppName, Sect, Item(i).Key, Item(i).Default)


    sAlphaInit = PCMagRegQueryValue("MPPager", "Config", "MAlphaInit", "ATM0V1")
    'If default setting save it to registry for future editing
    If sAlphaInit = "ATM0V1" Then
        PCMagSetKeyValue "MPPager", "Config", "MAlphaInit", "ATM0V1"
    End If
     
    sNumInit = PCMagRegQueryValue("MPPager", "Config", "MNumericInit", "ATM0V0")
    If sNumInit = "ATM0V0" Then
        PCMagSetKeyValue "MPPager", "Config", "MNumericInit", "ATM0V0"
    End If
    

End Sub


