VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "StuffCol"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'Copyright (c) 1996  Ziff-Davis Publishing Company.
'All rights reserved.
'First Published in PC Magazine, US Edition, [CoverDate].
'
'Programmed by John McSorley
'
Option Explicit

'Our collection of keyed data or 'Stuff'
Private colStuff As New Collection



Public Function Add(Key As String, Default As String, vType As Integer) As Stuff
'Purpose: add new item to collection
    
    Dim oNewStuff As New Stuff
    
    With oNewStuff
        .Key = Key
        .Default = Default
        .vType = vType
        'colStuff.Add oNewStuff, UCase$(Key)
        colStuff.Add oNewStuff, Key
        
    End With
    
    Set Add = oNewStuff
    
    
End Function


Public Function Count() As Long
'Purpose: return count of items in collection
    
    Count = colStuff.Count
    
End Function


Public Function FillForm(oForm As Form) As Integer
' Purpose: Fill a form from a values collection
'
'
    Dim i As Integer
    Dim j As Integer
    Dim oCtl As Control
    Dim sValue As String
    Dim sToken As String
    
    On Error GoTo FillFormErr
    
    'Loop through controls collection
    For i = 0 To oForm.Controls.Count - 1
        'set a control pointer for easy refrence
        Set oCtl = oForm.Controls(i)
        
        'Does the control have a tag? then set it's value
        If Trim$(oCtl.Tag) <> "" Then
            'Perform control specific settings
            If TypeOf oCtl Is TextBox Then
                'check for null
                If Trim$(Item(oCtl.Tag).Value) <> "" Then
                    oCtl = Item(oCtl.Tag).Value
                End If
            ElseIf TypeOf oCtl Is Label Then
                'label so
                oCtl = Item(oCtl.Tag).Value
                
            ElseIf TypeOf oCtl Is OptionButton Then
                'If option button check if value matches index
                If Item(oCtl.Tag).Value = oCtl.Index Then
                    'match so this is the one selected
                    oCtl.Value = True
                End If
            ElseIf TypeOf oCtl Is ComboBox Then
                'examine style of combo box
                If oCtl.Style = vbComboDropdownList Then
                    'dropdown list so select item from list
                    For j = 0 To oCtl.ListCount - 1
                        If UCase$(oCtl.List(j)) = UCase$(Item(oCtl.Tag).Value) Then
                            oCtl.ListIndex = j
                            Exit For
                        End If
                    Next j
                Else
                    'otherwise set text property to value
                    oCtl.Text = Item(oCtl.Tag).Value
                End If
            ElseIf TypeOf oCtl Is ListBox Then
                'list box so need to get items from value
                sValue = Item(oCtl.Tag).Value
                'clear list to be sure
                oCtl.Clear
                'Split value into tokens an add them to the list control
                Do Until sValue = ""
                    sToken = Token$(sValue, "|")
                    oCtl.AddItem sToken
                Loop
            ElseIf TypeOf oCtl Is CheckBox Then
                'check box so just set value
                oCtl.Value = Item(oCtl.Tag).Value
            
            Else
                'add other ElseIf(s) as needed for other control types
                
                'general controls could go here
                'ones where default property could map to value like:
                'oCtl=Item(oCtl.Tag).Value
                'None of these type in MailPage application
                            
            End If
            
        End If
    Next i
    
    'Call procedure to do any Form specific post processing based on filled controls
    oForm.FillDisplay
    
    FillForm = True
    
    Exit Function
    
FillFormErr:

    FillForm = False
    
    Exit Function
    


End Function

Public Function LoadAllSetOld(Sect As String) As Integer
'Purpose: Load all value settings from permanent storage

    Dim i As Integer
    Dim sValue As String
    
    For i = 1 To Count
        sValue = GetSetting(scAppName, Sect, Item(i).Key, Item(i).Default)
        Item(i).Value = sValue
    Next i
    
        
End Function


Public Function Item(ByVal Index As Variant) As Stuff
'Purpose: return item from collection

    On Error GoTo ItemErr
    
    Set Item = colStuff.Item(Index)
    Exit Function
    
ItemErr:

    Set Item = Nothing
    Exit Function
    
End Function


Public Function LoadAllSet(Sect As String) As Integer
'Purpose: Load all value settings from permanent storage

    Dim i As Integer
    Dim sValue As String
    
    For i = 1 To Count
        'sValue = GetSetting(scAppName, Sect, Item(i).Key, Item(i).Default)
        sValue = PCMagRegQueryValue(scAppName, Sect, Item(i).Key, Item(i).Default)
        Item(i).Value = sValue
    Next i

End Function

Public Function SaveAllSet(Sect As String) As Integer
'Purpose: Save all value settings to permanent stoarage

    Dim i As Integer
    Dim sValue As String
    
    For i = 1 To Count
        'SaveSetting scAppName, Sect, Item(i).Key, Item(i).Value
        PCMagSetKeyValue scAppName, Sect, Item(i).Key, Item(i).Value
    Next i


End Function

Public Function SaveAllSetOld(Sect As String) As Integer
'Purpose: Save all value settings to permanent stoarage

    Dim i As Integer
    Dim sValue As String
    
    For i = 1 To Count
        SaveSetting scAppName, Sect, Item(i).Key, Item(i).Value
    Next i

End Function


Public Function UnloadForm(oForm As Form) As Integer
'Purpose: take values from form and add them to collection

    Dim i As Integer
    Dim oCtl As Control
    Dim sValue As String
    Dim j As Integer
    
    For i = 0 To oForm.Controls.Count - 1
        Set oCtl = oForm.Controls(i)
        
        If Trim$(oCtl.Tag) <> "" Then
            If TypeOf oCtl Is TextBox Then
                sValue = oCtl.Text
                Item(oCtl.Tag).Value = sValue
                         
            ElseIf TypeOf oCtl Is Label Then
                sValue = oCtl
                Item(oCtl.Tag).Value = sValue
                
            ElseIf TypeOf oCtl Is OptionButton Then
                
                If oCtl.Value = True Then
                    Item(oCtl.Tag).Value = oCtl.Index
                End If
            
            ElseIf TypeOf oCtl Is ComboBox Then
                If oCtl.Style = 2 Then
                    'dropdown list
                    sValue = oCtl
                    Item(oCtl.Tag).Value = sValue
                Else
                    sValue = oCtl
                    Item(oCtl.Tag).Value = sValue
                End If
            ElseIf TypeOf oCtl Is ListBox Then
                sValue = ""
                For j = 0 To oCtl.ListCount - 1
                    If j < oCtl.ListCount - 1 Then
                        sValue = sValue & oCtl.List(j) & "|"
                    Else
                        sValue = sValue & oCtl.List(j)
                    End If
                Next j
                Item(oCtl.Tag).Value = sValue
            
            ElseIf TypeOf oCtl Is CheckBox Then
                Item(oCtl.Tag).Value = oCtl.Value
            
            End If
            
        End If
    Next i
    

End Function


